/* Copyright (c) 1997-1999 Miller Puckette.
* For information on usage and redistribution, and for a DISCLAIMER OF ALL
* WARRANTIES, see the file, "LICENSE.txt," in this distribution. */

/* iem-gui-lib written by Thomas Musil (c) IEM KUG Graz Austria 2000-2001 */

#ifdef NT
#pragma warning( disable : 4244 )
#pragma warning( disable : 4305 )
#endif

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "m_imp.h"
#include "g_canvas.h"
#include "t_tk.h"
#include "g_7_guis.h"

#ifdef NT
#include <io.h>
#else
#include <unistd.h>
#endif

t_symbol *iem_gui_key_sym=0;

int iem_gui_color_hex[]=
{
    16579836, 10526880, 4210752, 16572640, 16572608,
    16579784, 14220504, 14220540, 14476540, 16308476,
    14737632, 8158332, 2105376, 16525352, 16559172,
    15263784, 1370132, 2684148, 3952892, 16003312,
    12369084, 6316128, 0, 9177096, 5779456,
    7874580, 2641940, 17488, 5256, 5767248
};

int iem_gui_clip_size(int size)
{
    if(size < IEM_GUI_MINSIZE)
	size = IEM_GUI_MINSIZE;
    return(size);
}

int iem_gui_clip_font(int size)
{
    if(size < IEM_FONT_MINSIZE)
	size = IEM_FONT_MINSIZE;
    return(size);
}

int iem_gui_modulo_color(int col)
{
    while(col >= IEM_GUI_MAX_COLOR)
	col -= IEM_GUI_MAX_COLOR;
    while(col < 0)
	col += IEM_GUI_MAX_COLOR;
    return(col);
}

void str_xch_raute2dollar(t_symbol *s)
{
    if(s->s_name[0] == '#')
	s->s_name[0] = '$';
}

void str_xch_dollar2raute(t_symbol *s)
{
    if(s->s_name[0] == '$')
	s->s_name[0] = '#';
}

/* ------------------------ setup routine ------------------------- */

void bng_setup( void);
void hslider_setup( void);
void radiobut_setup( void);
void toggle_setup( void);
void my_canvas_setup( void);
void vslider_setup( void);
void vu_setup( void);

void g_7_guis_setup(void)
{
    bng_setup();
    hslider_setup();
    radiobut_setup();
    toggle_setup();
    my_canvas_setup();
    vslider_setup();
    vu_setup();
}
